library jaguar.example.routes.simple;

import 'dart:async';
import 'package:jaguar/jaguar.dart';
import 'package:jaguar/interceptors.dart';

part 'simple.g.dart';

class WrapSampleInterceptor extends RouteWrapper<SampleInterceptor> {
  SampleInterceptor createInterceptor() => new SampleInterceptor();
}

class SampleInterceptor extends Interceptor {
  FutureOr<Null> pre(Request req) {
    //TODO
    return null;
  }
}

/// Example of basic API class
@RouteGroup(path: '/api')
class SubGroup {
  WrapSampleInterceptor sampleInterceptor() => new WrapSampleInterceptor();

  /// Example of basic route
  @Route(path: '/ping')
  @Wrap(const [#sampleInterceptor])
  String normal() => "You pinged me!";

  @Post(path: '/:id')
  @WrapEncodeMapToJson()
  Map postRoute(int id) => {
    "Hello": "Dart",
  };

  @Put(path: '/:id')
  void voidRoute(String id) {}
}

/// Example of basic API class
@RouteGroup(path: '/api')
class MotherGroup {
  /// Example of basic route
  @Route(path: '/ping')
  String ping() => "You pinged me!";

  @Group(path: '/sub')
  final SubGroup subGroup = new SubGroup();
}
