part of jaguar_generator.validator;

class InputInterceptorTypeChecker implements Validator {
  final List<ParsedWrapper> interceptors;

  final ParameterElementWrap param;

  final ParsedInputInterceptor input;

  InputInterceptorTypeChecker(this.input, this.param, this.interceptors);

  void validate() {
    /* TODO
    ParsedWrapper inter = interceptors.firstWhere((inter) {
      return inter.name == input.resultFrom.name;
    }, orElse: () => null);

    if (inter == null) {
      final except =
          new InputInterceptorException('Interceptor not found for input!');
      except.input = input.resultFrom.name;
      except.param = param.name;
      throw except;
    }

    if (inter.pre == null) {
      final except = new InputInterceptorException(
          "An interceptor that doesn't have pre has been used as input!");
      except.interceptor = inter.name;
      except.input = input.resultFrom.name;
      except.param = param.name;
      throw except;
    }

    if (inter.returnsFutureFlattened.isVoid) {
      final except = new InputInterceptorException(
          "An interceptor that returns void has been used as input!");
      except.interceptor = inter.name;
      except.input = input.resultFrom.name;
      except.param = param.name;
      throw except;
    }

    if (!inter.returnsFutureFlattened.isAssignableTo(param.type)) {
      final except = new InputInterceptorException(
          "Interceptor's result type does not match input's param type!");
      except.interceptor = inter.name;
      except.input = input.resultFrom.name;
      except.param = param.name;
      throw except;
    }
    */
  }
}

/// Validates that the return type of the interceptor and the type of the
/// param are assignable.
class InputTypeChecker implements Validator {
  final ChainFunction host;

  final int inputIndex;

  final List<ParsedWrapper> interceptors;

  InputTypeChecker(this.host, this.inputIndex, this.interceptors);

  void validate() {
    final ParsedInput input = host.inputs[inputIndex];
    final int paramIdx = host.numDefaultInputs + inputIndex;
    final param = host.method.requiredParameters[paramIdx];

    Validator checker;

    if (input is ParsedInputInterceptor) {
      checker = new InputInterceptorTypeChecker(input, param, interceptors);
    }

    checker?.validate();
  }
}
