part of jaguar_generator.writer;

class InterceptorCreateMethodWriter extends Object with GenInputs {
  final Route _r;

  final Interceptor _i;

  InterceptorCreateMethodWriter(this._r, this._i);

  InterceptorCreatorMethod get _c => _i.creator;

  List<Input> get _inputs => _c.inputs;

  String generate() {
    StringBuffer sb = new StringBuffer();
    sb.write('final RouteWrapper ${_i.genWrapperName} = ');
    if(_c.isAsync) {
      sb.write('await ');
    }
    sb.write('_internal.${_c.name}(');

    if (_c.needsHttpRequest) {
      sb.write("request, ");
    }

    sb.write(_genInputs);
    sb.writeln(');');

    sb.writeln('${_i.genInstanceName} = ${_i.genWrapperName}.createInterceptor();');
    return sb.toString();
  }
}

class InterceptorCreatorInstanceWriter {
  final Route _r;

  final Interceptor _i;

  InterceptorCreatorInstanceWriter(this._r, this._i);

  InterceptorCreatorInstance get _c => _i.creator;

  String generate() {
    StringBuffer sb = new StringBuffer();
    sb.write('final RouteWrapper ${_i.genWrapperName} = const ${_c.instantiationStr};');

    sb.writeln('${_i.genInstanceName} = ${_i.genWrapperName}.createInterceptor();');
    return sb.toString();
  }
}
